/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999, D.Palomo van Es                                   *
 *                                                                       *
 * Permission to use, copy, modify, distribute and sell this software    *
 * and its documentation for any purpose is hereby granted without fee,  *
 * provided that the above copyright notice appear in all copies and     *
 * that both that copyright notice and this permission notice appear     *
 * in supporting documentation. This software is provided "as is"        *
 * without express or implied warranty.                                  *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *  clpq is a little program that constantly shows the printerqueue for  *
 *  1 printer and can only be used by root when spoolfiles are unreadable*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                      clpq version 0.3dcl1                             *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include"clpq.h"

lp_obj *files[MAXENTRIES];
CPr     pr;

int Jobdecode(char n[]){
   int i, j, hulp = 0;

   for (j = 0; n[j] != 'A'; j++);
   for (i = j + 1; n[i] >= '0' && n[i] <= '9' ; i++){
      hulp += n[i] - '0';
      if (n[i+1] >= '0' && n[i+1] <= '9')
         hulp *= 10;
      }
   return hulp;
}

bool printing_enabled() {
   char buff[300], hulp[40];
   int rc;
   sprintf(buff, "test \"$(lpc -P%s status | cut -c20-27)\" == \"Printing\n enabled\"", pr.queue);
   rc = system(buff);
   if (rc == 0)
      return true;
   return false;
}

bool spooling_enabled() {
   char buff[300], hulp[40];
   int rc;
   sprintf(buff, "test \"$(lpc -P%s status | cut -c29-36)\" == \"Spooling\n enabled\"", pr.queue);
   rc = system(buff);
   if (rc == 0)
      return true;
   return false;
}

void print (WINDOW *stdscr, int marked) {
   int   i = 0,               // Some counters 
         j = 0, 
         y = 0, 
         x = 0;
   int selected = 0;
   char hulp = 0, 
        hulp2[4];             // Not very clean, used for strcat
   static int firstline  = 0; // We start at line 0
   
   int startline = STARTLINE; // Where do you want to start the text
 
   clear();                // Clear window
   
   getmaxyx(stdscr, y, x); // Get size of the window

   // If the 'marked line' falls out of boundaries
   // scroll down.
   if (marked >= y - startline) { 
      firstline = marked - (y - 1 - startline);
      startline--;         // This is a correction on the startline,
                           // when the y-boundary is reached the startline 
                           // shifts (??? ==> maybe a bug ;-) )
   }
   else 
      firstline = 0;
      
   char pe1, pe2, se1, se2;
   if (printing_enabled() == true ) {
      pe1 = '*' ; pe2 = ' ';
   } else {
      pe1 = ' ' ; pe2 = '*';
   }

   if (spooling_enabled() == true ) {
      se1 = '*' ; se2 = ' ';
   } else {
      se1 = ' ' ; se2 = '*';
   }

   move (0,0);             // Place your title. 
   attron(COLOR_PAIR(12));
   printw("                CLPQ Version %s                  \n\n\n", version);
   attroff(COLOR_PAIR(12));
   attron(COLOR_PAIR(15));
   printw("       Up / Down arrow: move selection-line       \n");
   printw(" (a)larm set (u)nset alarm (r)emove (q)uit (h)elp \n");
   printw("         Spooling: %c(e)enable  %c(d)disable        \n",se1,se2);
   printw("         Printing: %c(+)enable  %c(-)disable        \n\n",pe1,pe2);
   attroff(COLOR_PAIR(15));
   printw("%4s :%-2s %-20s %-14s %5s\n","Rank", " A", " Filename", " Owner", "Job");
   printw(" - - - - - - - - - - - - - - - - - - - - - - - - -\n");
   move (startline, 0);    // Goto startline

   for (i = 0; i < MAXENTRIES + 1; i++)
      for (int j = 0; j < 256; j++)
         Buffer[i][j] = 0;


   for (i = 0; i < MAXENTRIES; i++)
      if (files[i] != NULL) {
         files[i]->jn = Jobdecode(files[i]->cname);
         for (j = 0; j < MAXENTRIESALARM; j++) {
            if (Alarm[j][0] == files[i]->jn) {
               selected = 1;
               break;
            }
         }
         if (selected) {
         if (files[i]->N == NULL)
	          sprintf(Buffer[i], "%4d :%-2s %-20s %-14s %5d\n", i, " M", " File Unknown", " root", files[i]->jn);
	       else {
            if (!strcmp(files[i]->N, " "))
               strcpy(files[i]->N, " Standard Input");  
	          sprintf(Buffer[i], "%4d :%-2s %-20s %-14s %5d\n", i, " M", files[i]->N,
	          files[i]->L, files[i]->jn);
	       }
         selected = 0;
         } else {
            if (files[i]->N == NULL)
	          sprintf(Buffer[i], "%4d :%-2s %-20s %-14s %5d\n", i, "  ", " File Unknown", " root", files[i]->jn);
	       else {
            if (!strcmp(files[i]->N, " "))
               strcpy(files[i]->N, " Standard Input");  
	          sprintf(Buffer[i], "%4d :%-2s %-20s %-14s %5d\n", i, "  ", files[i]->N,
	          files[i]->L, files[i]->jn);
	       }

         }
      }

   for (j = firstline; j < i && j < (y + firstline - startline); j++) {
      if (j == marked)  {
         // attron / attroff : add / remove a attribute from the internal attr. list
         // A_STANDOUT    : Reversed video
         // COLOR_PAIR(n) : Use color pair n
         attron(A_STANDOUT);
         attron(COLOR_PAIR(10));
         // 'printf' - clone to print in the window
         printw("%s", Buffer[j]);
         attroff(A_STANDOUT);
         attroff(COLOR_PAIR(10));
      }
      else 
         printw("%s", Buffer[j]);
   }
}

void lp_obj::FillFields() {
   int i;
   bool several = false;
   char buffer[256];
   ifstream cfile(cname);
   
   for (i = 0;cfile >> buffer && !several; i++) 
      switch(buffer[0]) {
         case 'H': {H = new char[256]; strcpy(H, buffer); H[0] = ' ';}break;
         case 'P': {P = new char[256]; strcpy(P, buffer); P[0] = ' ';}break;
         case 'J': {J = new char[256]; strcpy(J, buffer); J[0] = ' ';}break;
         case 'L': {L = new char[256]; strcpy(L, buffer); L[0] = ' ';}break;
         case 'C': {C = new char[256]; strcpy(C, buffer); C[0] = ' ';}break;
         case 'T': {T = new char[256]; strcpy(T, buffer); T[0] = ' ';}break;
         case 'f': {f = new char[256]; strcpy(f, buffer); f[0] = ' ';}break;
         case 'l': {l = new char[256]; strcpy(l, buffer); l[0] = ' ';}break;
         case 'M': {M = new char[256]; strcpy(M, buffer); M[0] = ' ';}break;
         case 'U': {U = new char[256]; strcpy(U, buffer); U[0] = ' ';}break;
         case 'N': {if (N != NULL) several = true;
                    N = new char[256]; strcpy(N, buffer); N[0] = ' ';}break;
      }
   if (several) 
      strcpy (N, " Several Files");
   cfile.close();
}

lp_obj::lp_obj() {
   cname = NULL; 
   H = NULL;     
   P = NULL;     
   J = NULL;     
   L = NULL;     
   C = NULL;     
   T = NULL;     
   f = NULL;     
   l = NULL;     
   M = NULL;     
   U = NULL;     
   N = NULL;     
}

lp_obj::~lp_obj() {
   delete cname; 
   delete H;
   delete P;
   delete J;
   delete L;
   delete C;
   delete T;
   delete f;
   delete l;
   delete M;
   delete U;
   delete N;
}


void Termination (){
   char temp[83];
   sprintf(temp, "rm %s; rm /tmp/.%stemp.___; rm /tmp/.%serr.log", confname, getpwuid(getuid())->pw_name, getpwuid(getuid())->pw_name);
   system(temp);
}


void Call_once (WINDOW *stdscr){
   int i;
   char buffer[MAXFILES], hulp[40];
   
   n = 0;
     
   for (i = 0; i < MAXFILES; i++)
      buffer[i] = 0;
   sprintf(hulp, "/tmp/.%stemp.___", getpwuid(getuid())->pw_name);
   ifstream lp_files(hulp);
   
   if (!lp_files)
      cerr << "Could not write tempfiles properly" << endl;
   for (i = 0; lp_files >> buffer; i++) {
      files[i] = new lp_obj;
      files[i]->cname = new char[MAXLCNAME];
      strcpy(files[i]->cname, buffer);
   }
   //update the fields:
   for (i = 0; files[i] != NULL; i++) {
      n++;
      files[i]->FillFields();
   }
   print(stdscr, Marked);
   lp_files.close();
} 

void strshift(char *s, int n, int size) {
   int i;
   char hulp[strlen(s) - 1];
   
   for (i = n; i < strlen(s); i++)
      hulp[i - n] = s[i];
      
   hulp[i - n] = '\0'
;   strcpy(s, hulp);
}

// return the config file item and set value in the argument char* (it MUST be a variable string)
CONFTYPE decode (char *ioline) {
   char hulp[256];
   int i;
   
   for(i = 0; i < 256; i++)
      hulp[i] = 0;
   for(i = 0; ioline[i] != '=' && i < 256 && ioline[i] != '#'; i++)
      hulp[i] = ioline[i];
   if (ioline[i] == '#')
      return COMMENT;
   if (ioline[i] != '=')
      return UNKNOWN;
   strshift(ioline, i + 1, 256);
   
   if (strcmp(hulp, "Path") == 0 || strcmp(hulp, "path") == 0) 
      {pr.path = new char[256]; strcpy(pr.path, ioline); return PATH;}
   if (strcmp(hulp, "Queue") == 0 || strcmp(hulp, "queue") == 0) 
      {pr.queue = new char[256]; strcpy(pr.queue, ioline); return QUEUE;}
   if (strcmp(hulp, "Refreshrate") == 0 || strcmp(hulp, "refreshrate") == 0) 
      {pr.rrate = atoi(ioline); return RRATE;}
   if (strcmp(hulp, "Alarm") == 0 || strcmp(hulp, "alarm") == 0) 
      {pr.alarmline = new char[256]; strcpy(pr.alarmline, ioline); pr.systembeep = false; return ALARM;}   
   return UNKNOWN;
}
  
void empty(char *a, int size) {
   for(int i = 0; i < size; i++) a[i] = 0;
}
  
void init_conf() {
    int i, t;
    char buffer[256];
    char temp[40];
    ac = 0;
    
    pr.systembeep = true;
    
    for (i = 0; i < MAXENTRIESALARM; i++){
       Alarm[i][0] = 0;
       Alarm[i][1] = 0; 
    }
    strcpy(confname, "/tmp/.");
    strcat(confname, getpwuid(getuid())->pw_name);
    sprintf(temp,"cp ~%s/.clpqconf /tmp/.%sclpq", getpwuid(getuid())->pw_name, getpwuid(getuid())->pw_name);
    system (temp);
    strcat(confname, "clpq");
    ifstream lp_conf (confname);
    for (i = 0; !lp_conf.eof(); i++) {
      lp_conf.getline(buffer, 256);
      if (strlen(buffer) > 3) {
         t  = decode(buffer);
         empty(buffer, 256);
         if (t == UNKNOWN && !lp_conf.eof()) {
            lp_conf.close();
            sprintf(temp, "rm /tmp/.%sclpq", getpwuid(getuid())->pw_name);
            system(temp);
            endwin();
            cerr << "Syntax Error in .clpqconf file at line " << i + 1 << "." << endl;
            exit(0);
         }
      }
    }
    lp_conf.close();
    strcpy(login, getpwuid(getuid())->pw_name);
}
  
void Buffered_ls (WINDOW *stdscr){
   int i;
   char ls[280] = "ls -A1 ", hulp[280];
   sprintf(hulp, "ls -A1 %s/cf* > /tmp/.%stemp.___ 2> /tmp/.%serr.log", pr.path, getpwuid(getuid())->pw_name, getpwuid(getuid())->pw_name);
   system(hulp);
   if (startup == true)
      Call_once(stdscr);
}

void Kill_all() {
   for (int i = 0; files[i] != NULL; i++){
      delete files[i];
      files[i] = NULL;
   }   
}


void Checker(WINDOW *stdscr) {
   int i;
   char buffer[MAXFILES], hulp[40];
   
   Buffered_ls(stdscr);   
   
   sprintf(hulp, "/tmp/.%stemp.___", getpwuid(getuid())->pw_name);
   ifstream lp_files(hulp);
   if (!lp_files)
      cerr << "Could not write tempfiles properly" << endl;
   
   lp_files >> buffer;
   if (files[0] == NULL || strcmp(buffer, files[0]->cname) != 0) {
      if (files[0] != NULL) 
      if (strcmp(buffer, files[0]->cname) != 0){//is the first one finished?
         for (int j = 0; j < MAXENTRIESALARM; j++)
            if(files[0]->jn == Alarm[j][0]) {
               if (pr.systembeep)
                 printf("\a \a \a");//$$$
               else 
                  system(pr.alarmline);
               break;
            }
         }
      if (files[0] == NULL && buffer[0] != '\0') {
            Call_once(stdscr);   
            lp_files.close();
            return;
      }
      else {   
         if (files[0] != NULL) {
            Kill_all();
            Call_once(stdscr);
            lp_files.close();
            return;
         }
      }
   }
   for (i = 1; files[i] != NULL; i++){
      lp_files >> buffer;
         if (files[i] != NULL && strcmp(buffer, files[i]->cname) != 0) {
            Kill_all();
            Call_once(stdscr);
            lp_files.close();
            return;
      }
   }
   lp_files >> buffer;
   if (buffer[0] != '\0')
      Call_once(stdscr);
 lp_files.close();
}

void dequeue(int j) {
   char buff[300], hulp[40];
   sprintf(buff, "lprm -P%s %d >/dev/null 2> /tmp/.%serr.log", pr.queue, j, getpwuid(getuid())->pw_name);
   system (buff);
   sprintf(hulp, "/tmp/.%serr.log", getpwuid(getuid())->pw_name);

   ifstream err_ (hulp);
   int i;
   for (i = 0; err_ >> buff; i++);
   if (i >= 1) {
      move(STARTLINE - 2, 0);
      printw ("Permission Denied!!");
   }
   err_.close();
}

void lpc_stop() {
   char buff[300], hulp[40];
   sprintf(buff, "lpc -P%s stop >/dev/null 2> /tmp/.%serr.log", pr.queue, getpwuid(getuid())->pw_name);
   system (buff);      /* Hmm... This doesn't seem to ever return an error */
   sprintf(hulp, "/tmp/.%serr.log", getpwuid(getuid())->pw_name);
  
   ifstream err_ (hulp);
   int i;
   for (i = 0; err_ >> buff; i++);
   if (i >= 1) {
      move(STARTLINE - 2, 0);
      printw ("Permission Denied!!");
   }
   err_.close();
}

void lpc_start() {
   char buff[300], hulp[40];
   sprintf(buff, "lpc -P%s start >/dev/null 2> /tmp/.%serr.log", pr.queue, getpwuid(getuid())->pw_name);
   system (buff);      /* Hmm... This doesn't seem to ever return an error */
   sprintf(hulp, "/tmp/.%serr.log", getpwuid(getuid())->pw_name);

   ifstream err_ (hulp);
   int i;
   for (i = 0; err_ >> buff; i++);
   if (i >= 1) {
      move(STARTLINE - 2, 0);
      printw ("Permission Denied!!");
   }
   err_.close();
}

void lpc_disable() {
   char buff[300], hulp[40];
   sprintf(buff, "lpc -P%s disable >/dev/null 2> /tmp/.%serr.log", pr.queue, getpwuid(getuid())->pw_name);
   system (buff);      /* Hmm... This doesn't seem to ever return an error */
   sprintf(hulp, "/tmp/.%serr.log", getpwuid(getuid())->pw_name);

   ifstream err_ (hulp);
   int i;
   for (i = 0; err_ >> buff; i++);
   if (i >= 1) {
      move(STARTLINE - 2, 0);
      printw ("Permission Denied!!");
   }
   err_.close();
}

void lpc_enable() {
   char buff[300], hulp[40];
   sprintf(buff, "lpc -P%s enable >/dev/null 2> /tmp/.%serr.log", pr.queue, getpwuid(getuid())->pw_name);
   system (buff);      /* Hmm... This doesn't seem to ever return an error */
   sprintf(hulp, "/tmp/.%serr.log", getpwuid(getuid())->pw_name);

   ifstream err_ (hulp);
   int i;
   for (i = 0; err_ >> buff; i++);
   if (i >= 1) {
      move(STARTLINE - 2, 0);
      printw ("Permission Denied!!");
   }
   err_.close();
}

bool remove(int job) {
   int i;
   char temp[41];
   
   temp[0] = 0;
   temp[0] = ' ';
   temp[1] = '\0';
   strcat(temp, login);

   move (STARTLINE - 3,0);
   attron(COLOR_PAIR(13));
   if (files[job] != NULL)
      printw("Are you sure you want to remove job %d? [Y]",
      files[job]->jn);      
   else
      printw("You cannot delete nothing!                 ");   
   attroff(COLOR_PAIR(13));
   for (;;) {
      int c = getch();
      if (c == 'y' || c == '\n' || c == 'y') {
         if (files[job] != NULL)
            if (strcmp(temp, files[job]->P) == 0 || strcmp(temp, " root") == 0) { 
               dequeue(files[job]->jn);   
               return true;   
            }
            else {
               move(STARTLINE - 2, 0);
               attron(COLOR_PAIR(13));
               printw("Permission Denied.                          ",
               files[job]->P, login);
               getch();
               attroff(COLOR_PAIR(13));
               return false;
            }
      }
      else 
         return false;
   }
   
}

void unsetalarm(int job) {
   for (int i = 0; i < MAXENTRIESALARM; i++)
      if (Alarm[i][0] == files[job]->jn) {
         Alarm[i][0] = 0; Alarm[i][1] = 0;
         return;
      }
}

void setalarm(int job) {
   for (int i = 0; i < MAXENTRIESALARM; i++)
      if (Alarm[i][0] == files[job]->jn)
         return;
         
   if (ac < MAXENTRIESALARM) {
      ac++;
      Alarm[ac][0] = files[job]->jn;
      Alarm[ac][1]   = 1;
   }
}


void helpscreen(WINDOW *stdscr) {
   int x,y;
   
   clear();                // Clear window
   getmaxyx(stdscr, y, x); // Get size of the window
   attron(COLOR_PAIR(11));
   printw( "                            Help                            \n");
   attroff(COLOR_PAIR(11));
   if (y <= 10 || x <= 59)
      printw("You should enlarge your window \nfor a better view of this screen.\n");
   else  
   printw( "CLPQ has the following command-keys:\n\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n",
           "'a' or 'A'  : Set the alarm on the job the",
           "              selection-line highlights.",
           "'u' or 'U'  : Unset the alarm on the job the selection-line",
           "              highlights.",
           "'r' or 'R'  : Remove the job the selection-line highlights.",
           "'d' or 'D'  : Disable spooling.",
           "'e' or 'E'  : Enable spooling.",
           "'-'         : Disable printing.",
           "'+' or '='  : Enable printing.",
           "'q' or 'Q'  : Quit CLPQ.",
           "'h' or 'H'  : Display this helpscreen.");
   move (y-1, 0);   
   attron(COLOR_PAIR(15));
   printw("Press [SpaceBar] to continue.");
   attroff(COLOR_PAIR(15));
   for(;;) {
      int c = getch();
      if (isgraph(c) || c == ' ' || c == '\n')
         return;
   }
}

static void finish(int sig) {
    endwin();
    Termination();
    
    exit(0);
}

main(int argc, char *argv[]) {
   (void) signal(SIGINT, finish);  // arrange interrupts to terminate 
   (void) initscr();               // initialize the curses library 
   keypad(stdscr, TRUE);           // enable keyboard mapping
   (void) nonl();                  // tell curses not to do NL->CR/NL on output
   (void) cbreak();                // take input chars one at a time, no wait for \n
   (void) noecho();                // don't echo input
   init_conf();
   bool removed = false;

   if (has_colors()) {
      start_color();
      //Simple color assignment, often all we need.
      init_pair(10, COLOR_BLUE, COLOR_WHITE);
      init_pair(11, COLOR_BLUE, COLOR_YELLOW);
      init_pair(12, COLOR_CYAN, COLOR_BLUE);
      init_pair(13, COLOR_RED, COLOR_YELLOW);
      init_pair(15, COLOR_BLACK, COLOR_WHITE);
   }


   halfdelay(pr.rrate);
   startup = true;
   Buffered_ls(stdscr);
   startup = false;
   print(stdscr, 0);                // First Print-out to screen
   for (;;) {                       // refresh, accept single keystroke of input                   
     Checker(stdscr);
     int c = getch();    /* AARGH!  Something leaks here.  Whenever there are
                            no jobs in the queue, and you press "u" or "a", 
                            the program segfaults right here. */
      // process the command keystroke 
      switch (c) {
         case KEY_DOWN: if (n > 0) {(Marked >= n - 1)? Marked = n - 1: Marked++;
                           print(stdscr, Marked);}    break;
         case KEY_UP:   if (n > 0) {(Marked == 0)? Marked = 0: Marked--;
                           print(stdscr,Marked);}               break;
         case 'q': case 'Q': finish(0);                          break;
         case 'r': case 'R': if (n > 0) {removed = remove(Marked);print(stdscr,Marked);
                           if (removed && Marked > 0) Marked--;}break;
         case 'a': case 'A': setalarm(Marked); print(stdscr, Marked); break;
         case 'u': case 'U': unsetalarm(Marked); print(stdscr, Marked); break;
         case '+': case '=': lpc_start(); print(stdscr, Marked); break;
         case '-': lpc_stop(); print(stdscr, Marked); break;
         case 'd': case 'D': lpc_disable(); print(stdscr, Marked); break;
         case 'e': case 'E': lpc_enable(); print(stdscr, Marked); break;
         case 'h': case 'H': helpscreen(stdscr); print(stdscr, Marked); break;
      }
   }
    finish(0);                      // we're done 
}
