/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999, D.Palomo van Es                                   *
 *                                                                       *
 * Permission to use, copy, modify, distribute and sell this software    *
 * and its documentation for any purpose is hereby granted without fee,  *
 * provided that the above copyright notice appear in all copies and     *
 * that both that copyright notice and this permission notice appear     *
 * in supporting documentation. This software is provided "as is"        *
 * without express or implied warranty.                                  *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *  clpq is a little program that constantly shows the printerqueue for  *
 *  1 printer and can only be used by root when spoolfiles are unreadable*
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                      clpq version 0.3                                 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

#include <unistd.h>
#include <sys/types.h>
#include <cctype>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <curses.h>
#include <signal.h>
#include <string.h>
#include <pwd.h>

#define version "0.3dcl1"
#define MAXLENGTHFILE     256
#define MAXLENGTHFILELINE 256
#define STARTLINE           10
#define CYCLETIME 2
#define MAXFILES 100000
#define MAXENTRIES 1000
#define MAXENTRIESALARM 256
#define MAXLCNAME 40
#define delay 100
/* some globals */
bool startup;
char Buffer[MAXENTRIES + 1][256];
int  Marked = 0;                // The line to be 'marked'
int  n;
char dirname[256];
char login[40];
int  rrate;
char confname[80];
enum CONFTYPE {PATH, RRATE, NoPr, UNKNOWN, ALARM, ALARMTYPE, QUEUE, COMMENT};
int  Alarm[MAXENTRIES][2];
int  ac;
bool systembeep;

class lp_obj {
public:
   char *cname; //Name of the c file of this object
   char *H;     //Hostname from which it was invoked
   char *P;     //Print-user who invoked the comm.
   char *J;     //Current Job
   char *L;     //Litteral Theline contains id info from passwd file. (for the banner page)
   char *C;     //Classification, also for the banner page
   char *T;     //String to be used as title for pr1
   char *f;     //Formatted, next to be printed file
   char *l;     //like f, but passes control chars and no page breaks
   char *M;     //Send mail to the specified user when Job is done
   char *U;     //name of file to br removed after completion of pr/ing
   char *N;     //name of the file to be printed, blan==>stdinput
   int  jn;
   lp_obj();
   ~lp_obj();
   void FillFields();
};

class CPr {
public:
   char *path;
   char *queue;
   int   rrate;
   char *alarmline;
   int   nopr;
   bool  systembeep;
};
